VR-Forces 5.0.2 Developer's Guide
 All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
railPathControllerPSR.h
Go to the documentation of this file.
1 /*******************************************************************************
2 ** Copyright (c) 2015 MAK Technologies, Inc.
3 ** All rights reserved.
4 *******************************************************************************/
5 
8 
9 #pragma once
10 
12 #include "vrfobjcore/simObject.h"
13 #include "readerWriter/rwVector.h"
14 #include <readerWriter/rwString.h>
15 #include <readerWriter/rwInt.h>
17 #include "vrfutil/rwRailSegment.h"
18 #include <vrfutil/rwUUID.h>
19 
25 
28 {
29 public:
32  const DtString& rwName = DtString::nullString(),
33  DtReaderWriterRegistry* parentRegistry = 0);
34 
37  const DtString& rwName = DtString::nullString(),
38  DtReaderWriterRegistry* parentRegistry = 0);
39 
41  virtual ~DtRailPathControllerPSR();
42 
45 
48  const DtString& rwName = DtString::nullString(),
49  DtReaderWriterRegistry* parentRegistry = 0) const;
50 
52  virtual DtString type() const;
53 
54  virtual void clear();
55 
56  virtual void clearPath();
57 
60  virtual const DtRwRailSegmentList& pathList() const;
61  virtual DtRwRailSegmentList& pathList();
62  virtual void addSegmentToPath(const DtRailSegment& seg,bool appendToEnd = true);
63  virtual void addRailSegments(DtRailSegmentList*);
65 
69  virtual void setDestination(const DtUUID& destination);
70 
72  virtual DtSimObjectReference destination() const;
73 
75  virtual bool destinationSpecified() const;
77  virtual void unspecifyDestination();
79 
83  virtual void setDestinationLocation(const DtVector& destinationLocation);
84  virtual DtVector destinationLocation() const;
86  virtual bool destinationLocationSpecified() const;
88  virtual void unspecifyDestinationLocation();
90 
95  virtual void setDebugPath(const DtUUID&);
96 
99  virtual const DtRwSimObjectReference& debugPath() const;
101  virtual bool debugPathSpecified() const;
103  virtual void unspecifyDebugPath();
105 
106 public:
107 
109  static DtVrfProcessStateRepository* creator (const DtString& rwName,
110  DtLocalObject* vrfObject, DtReaderWriterRegistry* parentRegistry);
111 
112 protected:
113 
122 
132 };
UUID is a unique ID wrapper class.
Definition: rwUUID.h:229
File: rwRailSegment.h.
std::list< DtRailSegment * > DtRailSegmentList
Definition: railSegment.h:197
DtRailSegment are segments entities can follow when using the rail movement system.
Definition: railSegment.h:23
The DtSimObjectReference is a shared pointer that can be used amongst many object for access to the u...
Definition: simObjectReference.h:26
Definition: readerWriterRegistry.h:39
Contains the DtUUID class declaration.
DtRwVector myDestinationLocation
Parameter Name: destination-location Parameter Description: Stores the geocentric location of the des...
Definition: railPathControllerPSR.h:128
Definition: rwVector.h:23
Specialized reader/writer version of the shared object reference that will encapsulate the actual sha...
Definition: simObjectReference.h:74
#define DT_DLL_vrfobjcore
This file is used to determine how to build.
Definition: vrfobjcoreDefines.h:24
virtual DtVrfProcessStateRepository * clone(const DtString &rwName=DtString::nullString(), DtReaderWriterRegistry *parentRegistry=0) const =0
DtRwSimObjectReference myDestination
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:125
class DtRailPathControllerPSR:
Definition: railPathControllerPSR.h:27
Class DtVrfProcessStateRepository: Abstract base class for all process state repositories. Process state repositories represent (potentially) shared, savable information for one or more components functioning together to achieve some process or set of processes; such as aiming and firing a weapon; moving an object; or just waiting a specified amount of time.
Definition: vrfProcessStateRepository.h:45
virtual DtString type() const =0
Returns the string type of the repository, as defined in procSRTypes.h.
DtRwSimObjectReference myDebugPath
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:121
DtRwRailSegmentList myPathList
Parameter Name: path Parameter Description: Stores the calculated rail path .
Definition: railPathControllerPSR.h:131
File: rwVector.h.
const DtVrfProcessStateRepository & operator=(const DtVrfProcessStateRepository &orig)
A locally simulated VRF object. Holds all internal and external data for the object, and provides access to both the current frame and next frame state data for the object. All current frame data is read-only, and next-frame data can be written to. No thread safety guarantees are made on this object during the simulation frame and it should only be accessed by the thread that is simulating the object.
Definition: localObject.h:86

Document ID: Generated on Sun Dec 4 20:22:03 EST 2022 from SVN revision 249613
Copyright © 2005-2021 MAK Technologies. All Rights Reserved (www.mak.com)